//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private XRayIndicator[] cacheXRayIndicator = null;

        private static XRayIndicator checkXRayIndicator = new XRayIndicator();

        /// <summary>
        /// This indicator displays volume at each price in different views 
        /// </summary>
        /// <returns></returns>
        public XRayIndicator XRayIndicator()
        {
            return XRayIndicator(Input);
        }

        /// <summary>
        /// This indicator displays volume at each price in different views 
        /// </summary>
        /// <returns></returns>
        public XRayIndicator XRayIndicator(Data.IDataSeries input)
        {
            if (cacheXRayIndicator != null)
                for (int idx = 0; idx < cacheXRayIndicator.Length; idx++)
                    if (cacheXRayIndicator[idx].EqualsInput(input))
                        return cacheXRayIndicator[idx];

            lock (checkXRayIndicator)
            {
                if (cacheXRayIndicator != null)
                    for (int idx = 0; idx < cacheXRayIndicator.Length; idx++)
                        if (cacheXRayIndicator[idx].EqualsInput(input))
                            return cacheXRayIndicator[idx];

                XRayIndicator indicator = new XRayIndicator();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                XRayIndicator[] tmp = new XRayIndicator[cacheXRayIndicator == null ? 1 : cacheXRayIndicator.Length + 1];
                if (cacheXRayIndicator != null)
                    cacheXRayIndicator.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheXRayIndicator = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// This indicator displays volume at each price in different views 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.XRayIndicator XRayIndicator()
        {
            return _indicator.XRayIndicator(Input);
        }

        /// <summary>
        /// This indicator displays volume at each price in different views 
        /// </summary>
        /// <returns></returns>
        public Indicator.XRayIndicator XRayIndicator(Data.IDataSeries input)
        {
            return _indicator.XRayIndicator(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// This indicator displays volume at each price in different views 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.XRayIndicator XRayIndicator()
        {
            return _indicator.XRayIndicator(Input);
        }

        /// <summary>
        /// This indicator displays volume at each price in different views 
        /// </summary>
        /// <returns></returns>
        public Indicator.XRayIndicator XRayIndicator(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.XRayIndicator(input);
        }
    }
}
#endregion
